/* FILE: mmsolve.cc                 -*-Mode: c++-*-
 *
 * Skeleton for mmsolve interpreter shell application.
 *
 */

#include <tcl.h>

#include "mmsolve.h"	/* Mmsolve_Init, Mmsolve_SafeInit */
/* End includes */     

int Tcl_AppInit(Tcl_Interp *interp)
{
    Oc_AutoBuf ab;
    Tcl_DString buf;

    Oc_SetDefaultTkFlag(0);
    if (Oc_Init(interp) == TCL_ERROR) {
       return TCL_ERROR;
    }
    if (Vf_Init(interp) == TCL_ERROR) {
        Tcl_DStringInit(&buf);
        Tcl_DStringAppend(&buf, ab("Oc_Log Log"), -1);
        Tcl_DStringAppendElement(&buf, Tcl_GetStringResult(interp));
        Tcl_Eval(interp, Tcl_DStringAppendElement(&buf, ab("error")));
        Tcl_DStringFree(&buf);
    }
    if (Mmsolve_Init(interp) == TCL_ERROR) {
        Tcl_DStringInit(&buf);
        Tcl_DStringAppend(&buf, ab("Oc_Log Log"), -1);
        Tcl_DStringAppendElement(&buf, Tcl_GetStringResult(interp));
        Tcl_Eval(interp, Tcl_DStringAppendElement(&buf, ab("panic")));
        Tcl_DStringFree(&buf);
        Tcl_Exit(1);
    }
    return TCL_OK;
}

int Oc_AppMain(int argc, char **argv)
{
  Oc_Main(argc, argv, Tcl_AppInit);
  return 0;
}

